<?php

	/* ============================================================	
					Palautelomakkeen käsittelijä
				Koodia muutettu viimeksi 21.04.2007 
					 Tehnyt: Mikko Vestola
				       MVnet  ::  http://www.mvnet.fi
	============================================================*/
	
	
/* Määritellään seuraavat muuttujat: 
- Ylläpidon sähköpostiosoite, johon lomakkeella lähetetyt tiedot lähetetään
- Kiitossivu, johon käyttäjä siirtyy automaattisesti lähetettyään lomakkeen
- Tieto siitä, tallennetaanko lähetetyt palautteet tiedostoon (true, jos haluat, että ne tallennetaan
ja false, jos haluat, että niitä ei tallenneta)
- Tiedosto, johon lähetetyt palautteet tallennetaan, jos valitsit, että palautteet tallennetaan. */

$emailLahetys = "sahkoposti@osoitteesi.fi";
$kiitosSivu = "http://www.sivusi.net/kiitossivusi.html";  // osoitteen alussa pitää olla "http://"
$palautteetTallennetaan = true;   // true (tallennetaan) tai false (ei tallenneta)
$tallennaTiedostoon = "palautteet.txt";  // Tämä tiedosto pitää chmodata muotoon 766


/* Funktio, joka lisää parametrina annettun tiedoston loppuun parametrina annetun lisättävän sisällön. */

function lisaaTiedostonLoppuun ($tiedosto, $lisattava)
{	
	ignore_user_abort(true);

	$fd = fopen ($tiedosto, "a"); 

	/* Tiedostoon voi kirjoittaa vain, jos sen saa lukittua. Näin vältytään (toivottavasti) virheistä, 
	joita tulisi, jos useampi kuin yksi yrittäisi kirjoittaa tiedostoon samaan aikaan. */
	
	if (flock($fd, LOCK_EX)) {
		fwrite($fd, $lisattava);
		flock($fd, LOCK_UN); 
	}
	
	fclose($fd);

	ignore_user_abort(false);
}	

/* Luetaan tyyppi-parametri, jolloin tiedetään, minkätyyppistä lomaketta ollaan käsittelemässä */
$tyyppi = $_POST['Tyyppi'];


/* ============================================================	
	<<<   Palautelomakkeen käsittely   >>>
============================================================*/

if ($tyyppi == 'PALAUTE') 
{
	// Tarkasteteen, onko kyseessä spämmibotti
	if($_POST['spam_esto'] != "14")
		exit("Vastasit väärin kysymykseen: 9+5 = ?");
		
	/* Luetaan lomakkeen lähettämät kentät muuttujiin */

	$nimi = $_POST['nimi'];
	$otsikko = $_POST['otsikko'];
	$teksti = $_POST['teksti'];
	$vastaus = $_POST['vastaus'];
	$email = $_POST['email'];

	/* Tehdään lomakkeen kentille tarkastukset, ettei ole liian lyhyitä/pitkiä kenttiä. */

	if (strlen($nimi) <2)
		exit ("Et antanut nimeäsi.");
	if (strlen($nimi) >50)
		exit ("Nimen pituus on rajoitettu 50 merkkiin.");
	if (strlen($otsikko) <3)
		exit ("Et kirjoittanut viestillesi otsikkoa (min. 3 merkkiä)");
	if (strlen($otsikko) >50)
		exit ("Otsikon pituus on rajoitettu 50 merkkiin.");
	if (strlen($teksti) <10)
		exit ("Et kirjoittanut palautteeseen tekstiä (min. 10 merkkiä)");
	if (strlen($teksti) >5100)
		exit ("Palaute-tekstin pituus on rajoitettu 5000 merkkiin.");
	if (strlen($email) >51)
		exit ("Sähköpostiosoitteen pituus on rajoitettu 50 merkkiin.");
	if ($vastaus=="vastataan")
	{
		// Jos valittiin, että halutaan palautteeseen vastaus, pitää antaa myös sähköpostiosoite
		if (strlen($email) <5)
			exit ("Valitsit, että haluat palautteeseesi vastattavan, mutta et antanut sähköpostiosoitettasi tai se on virheellinen!");
		if (!ereg("@", $email))
			exit ("Valitsit, että haluat palautteeseesi vastattavan, mutta et antanut sähköpostiosoitettasi tai se on virheellinen!");
	} 
	if (strlen($vastaus) >30) {
		exit ("Vastaus-kentän pituus rajoitettu 30 merkkiin.");
	} 

	
	/* Jos vastausta ei haluttu... */

	if ($vastaus != "vastataan") {
		$vastaus = "EI vastata";
		$email = "ei@vastata.net";
	} else
		$vastaus = "Vastataan";


	/* Otetaan ylös lähettäjän IP-osoitteet ja kellonaika yms. */

	$lahettajanIP = $_SERVER['REMOTE_ADDR'];
	$lahettajanHost = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	$lahettajanSelain = $_SERVER['HTTP_USER_AGENT']; 
	$aikaLahetetty = date('d.m.Y H:i:s');

	/* Lähetetään saadut tiedot sähköpostilla */

@mail("$emailLahetys", "Palaute :: $otsikko","
Palaute :: $otsikko
Palaute jätetty: $aikaLahetetty

Lähettäjän nimi: $nimi
Lähettäjän sähköposti: $email

Lähetetty viesti: 

$teksti


Vastataanko palautteeseen? : $vastaus

Lähettäjän IP-osoite: $lahettajanIP
Lähettäjän host: $lahettajanHost
Lähettäjän user-agent: $lahettajanSelain

","From: $emailLahetys\r\n"."Reply-To: $email");


/* Kirjoitetaan palaute ylös myös tekstitiedostoon */

$tallennaTeksti ="

-----------------------------------------------------------------------

Palaute :: $otsikko
Palaute jätetty: $aikaLahetetty

Lähettäjän nimi: $nimi
Lähettäjän sähköposti: $email

Lähetetty viesti: 

$teksti


Vastataanko palautteeseen? : $vastaus

Lähettäjän IP-osoite: $lahettajanIP
Lähettäjän host: $lahettajanHost
Lähettäjän user-agent: $lahettajanSelain";

	if ($palautteetTallennetaan)
		lisaaTiedostonLoppuun ($tallennaTiedostoon, $tallennaTeksti);

	/* Siirtyy kiitossivulle */

	header("Location: ".$kiitosSivu);

} 


else 
{
	/* Jos kyseessä on joku muu lomake kuin tyyppiä PALAUTE. */
	exit ("Lomakkeen tietoja ei pystytä käsittelemään. Tarkista lomake");
}


?>